local mod = ...



-- Building Asset Processor -------------------------------------------------------------------------------------
mod:registerAssetProcessor("models/Bridge1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Building -------------------------------------------------------------------------------------
mod:registerAsset({
	DataType = "BUILDING",
	Id = "BUILDING_AALSMEER_BRIDGE",
	Name = "BRIDGE",
	BuildingType = "TRANSPORTATION",
    AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
	BuildingPartSetList = {
		{
			Name = "BRIDGE",
			BuildingPartList = {
				"BUILDING_PART_AALSMEER_BRIDGE",
			},
		},
    },
})



-- Building Part -------------------------------------------------------------------------------------

-- Prefab
mod:registerAssetId("models/Bridge1.fbx/Prefab/Bridge.Part", "PREFAB_AALSMEER_BRIDGE")

-- Grounding
mod:registerPrefabComponent("PREFAB_AALSMEER_BRIDGE", { DataType = "COMP_GROUNDED", GroundToWater = true })

-- Comp Building Part
mod:registerPrefabComponent("PREFAB_AALSMEER_BRIDGE", { DataType = "COMP_BUILDING_PART", BuildingPartType = "MAJOR", })

-- Object Flag
mod:configurePrefabFlagList("models/Bridge1.fbx/Prefab/Bridge.Part", { "BRIDGE" })

-- Building Function
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_BRIDGE",
    Id = "BUILDING_FUNCTION_AALSMEER_BRIDGE",
})

-- Building Part
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_AALSMEER_BRIDGE",
    Name = "BRIDGE",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_AALSMEER_BRIDGE",
    },
    -- BuildingZone = {
    --     ZoneEntryList = {
    --         {
    --             Polygon = polygon.createRectangle( {3, 8}, {0, 0} ),
    --             Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
    --         },
    --     },
    -- },
    -- Cost = {
    -- 	BuildRightTaxes = { { Resource = "GOLD_COINS", Quantity = 10 } },
    -- 	UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 5 } },
    -- 	ResourceNeededList = {
    --         {
    --             { Resource = "WOOD", Quantity = 10 },
    --         },
    -- 	},
    -- },
    AssetBuildingFunction = "BUILDING_FUNCTION_AALSMEER_BRIDGE",
})
